<html>
	<head>
		<title>Midnight Stroll</title>
		<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
		<link rel="stylesheet" href="./style/webgl.css" type="text/css">
		
	    <!-- Fragment shader program -->
	    <script id="shader-fs" type="x-shader/x-fragment">
		    precision mediump float;

	    	// uniform attribute for setting texture coordinates
		    varying vec2 vTextureCoord;
	    	// uniform attribute for setting lighting
		    varying vec3 vLightWeighting;

			// uniform attribute for setting 2D sampler
		    uniform sampler2D uSampler;

		    uniform bool uHasTexture;
		    uniform vec4 uColor;

		    vec4 color;


		    void main(void) {
		    	// sample the fragment color from texture
		        vec4 textureColor = texture2D(uSampler, vec2(vTextureCoord.s, vTextureCoord.t));
		        //gl_FragColor = vec4(0.0, 1.0, 0.0, 1.0);
		        //gl_FragColor = vec4(textureColor.rgb * vLightWeighting, textureColor.a);
		        if (uHasTexture) {
		        	color = vec4(textureColor.rgb, textureColor.a);
		        } else {
		        	color = uColor;
		        }
		        gl_FragColor = color;
		        //gl_FragColor = vec4(0.0, 0.0, 1.0, 1.0); // za popravit..
		        
		    }
	    </script>

    
	    <!-- Vertex shader program -->	    
	    <script id="shader-vs" type="x-shader/x-vertex">
    		// atributes for setting vertex position, normals and texture coordinates
		    attribute vec3 aVertexPosition;
		    attribute vec3 aVertexNormal;
		    attribute vec2 aTextureCoord;

		    uniform mat4 uMVMatrix;	// model-view matrix
		    uniform mat4 uPMatrix;	// projection matrix
		    uniform mat3 uNMatrix;	// normal matrix

		    uniform vec3 uAmbientColor;	// ambient color uniform

		    uniform vec3 uLightingDirection;	// light direction uniform
		    uniform vec3 uDirectionalColor;		// light color

		    uniform bool uUseLighting;	// lighting switch

			// variable for passing texture coordinates and lighting weights
			// from vertex shader to fragment shader
		    varying vec2 vTextureCoord;
		    varying vec3 vLightWeighting;

		    void main(void) {
		    	// calculate the vertex position
		        gl_Position = uPMatrix * uMVMatrix * vec4(aVertexPosition, 1.0);
		        vTextureCoord = aTextureCoord;

		        if (!uUseLighting) {
		            vLightWeighting = vec3(1.0, 1.0, 1.0);
		        } else {
		        	// transform normals
		            vec3 transformedNormal = uNMatrix * aVertexNormal;

		            // calculate weight for directional light
		            //float directionalLightWeighting = max(dot(transformedNormal, uLightingDirection), 0.0);
		            float directionalLightWeighting = 1.0;

		            // calculate lighting
		            vLightWeighting = uAmbientColor + uDirectionalColor * directionalLightWeighting;
		        }
		    }
	    </script>
	</head>
	<body onload="loadMeshes()">
		<h1>Midnight Stroll</h1>
		<div id="content">
			<canvas id="glcanvas" width="1280px" height="720px" style="background-image:url('./assets/backgroundImage.jpg'); background-color: black; background-repeat:repeat-x">
				No <code>&lt;canvas&gt;</code> suppport in your browser.
			</canvas>
			<canvas id="text" width="1280px" height="720px"></canvas>
			<br />
			<br />
    (WASD movement, ENTER start/resume game, ESC pause game)
		</div>
		<div id="logger" style="height: 350px; overflow-y: scroll"></div>
		
		<script type="text/javascript" src="./scripts/glMatrix-0.9.5.min.js"></script>
		<!--<script type="text/javascript" src="./scripts/gl-matrix-2.4.0.js"></script>-->
		<script src="./scripts/webgl-obj-loader.js" type="text/javascript"></script>
		<script src="./scripts/game.js" type="text/javascript"></script>
	</body>
</html>